//-------------------------------------------------------------------
//
//                      GreedyInsertHeuristic.h
//
//
//    author: Michael Krger
//    date:   march 1998
//-------------------------------------------------------------------


#ifndef _AGD_GREEDY_INSERT_HEURISTIC_H
#define _AGD_GREEDY_INSERT_HEURISTIC_H


#include <AGD/TwoLayerCrossMin.h>

/*{\Manpage {GreedyInsertHeuristic} {} {Greedy Insert} {M} }*/

/*{\Mbaseclasses

\begin{hierarchy}{8}{4}
\hdclass{0}{3}{5.5}{AGDModule}
\arhook{5.5}{3.5}{6.5}
\hdclass{1}{1.5}{6}{TwoLayerCrossMin}
\arhook{7}{2}{8}
\hdclass{1.5}{0}{7}{GreedyInsertHeuristic}
\end{hierarchy}
}*/

class GreedyInsertHeuristic : public TwoLayerCrossMin {

/*{\Mdefinition
}*/

public:

	/*{\Mcreation M 5}*/

	GreedyInsertHeuristic() { }
	/*{\Mcreate  creates an instance |\Mvar| of type |\Mname|.}*/

	~GreedyInsertHeuristic() { }


	/*{\Moperations}*/

	void call (const leda_graph& G, Layer& L);
	/*{\Mop calls |\Mvar| for graph $G$ and layer $L$. Reorders the nodes
	on layer $L$.}*/

	void init (const leda_graph& G, const Hierarchy& /*H*/) {
		weight.init(G);
	}

	void cleanup () {
		weight.init();
	}

	AGDModule *clone() const {
		return new GreedyInsertHeuristic();
	}

private:

  leda_node_array<double> weight;
};


#endif
