//-------------------------------------------------------------------
//
//                        ShortestPathInserter.h
//
//
//    author: Thomas Ziegler
//            AGD-adaption: Carsten Gutwenger
//    date:   decembre 1997
//-------------------------------------------------------------------


#ifndef SHORTEST_PATH_INSERTER_H
#define SHORTEST_PATH_INSERTER_H


#include <AGD/EdgeInsertModule.h>


/*{\Manpage {ShortestPathInserter} {} {Shortest Path Edge Inserter} {I} }*/

/*{\Mbaseclasses

\begin{hierarchy}{8}{4}
\hdclass{0}{3}{5.5}{AGDModule}
\arhook{5.5}{3.5}{6.5}
\hdclass{1}{1.5}{6}{EdgeInsertModule}
\arhook{7}{2}{8}
\hdclass{2}{0}{6.5}{ShortestPathInserter}
\end{hierarchy}
}*/

class ShortestPathInserter : public EdgeInsertModule {

/*{\Mdefinition
...

\horizline
\commoninfo{Shortest Path Inserter}{Shortest Path Edge Inserter}{}{Thomas Ziegler}
{decembre 1997}{}

\headerline{Pre- and Postcondition}
\begin{tabular}{l@{ = }l}
precondition & $\{\,  \,\}$ \\
postcondition(|PRE|) & $\{\,  \,\}$
\end{tabular}

\horizline
}*/

public:

	/*{\Mcreation}*/

	ShortestPathInserter() : EdgeInsertModule() { }
	/*{\Mcreate creates an instance |\Mvar| of type |\Mname|.}*/

	~ShortestPathInserter() { }


	leda_string name () const {
		return leda_string ("Shortest Path Inserter");
	}

	leda_string long_name () const {
		return leda_string ("Inserting Edges Using Shortest Path");
	}

	leda_string impl_author () const {
		return leda_string ("Thomas Ziegler");
	}

	leda_string impl_date () const {
		return leda_string ("decembre 1997");
	}

	AGDModule *clone() const {
		return new ShortestPathInserter;
	}

protected:

	void _call (PlaneGraphCopy& PG, leda_list<leda_edge>& e_insert);

};


#endif
