//-------------------------------------------------------------------
//
//                         SplitHeuristic.h
//
//
//    author: Michael Krger
//    date:   march 1998
//-------------------------------------------------------------------


#ifndef _AGD_SPLIT_HEURISTIC_H
#define _AGD_SPLIT_HEURISTIC_H

#include <AGD/TwoLayerCrossMin.h>

/*{\Manpage {SplitHeuristic} {} {Split Heuristic} {M} }*/

/*{\Mbaseclasses

\begin{hierarchy}{8}{4}
\hdclass{0}{3}{5.5}{AGDModule}
\arhook{5.5}{3.5}{6.5}
\hdclass{1}{1.5}{6}{TwoLayerCrossMin}
\arhook{7}{2}{8}
\hdclass{2.5}{0}{6}{SplitHeuristic}
\end{hierarchy}
}*/

class CrossingsMatrix;

class SplitHeuristic : public TwoLayerCrossMin {

/*{\Mdefinition
}*/

public:

	/*{\Mcreation M 5}*/

	SplitHeuristic() { }
	/*{\Mcreate  creates an instance |\Mvar| of type |\Mname|.}*/

	~SplitHeuristic() { }


	/*{\Moperations}*/

	void call( const leda_graph &G, Layer &L );
	/*{\Mop calls |\Mvar| for graph $G$ and layer $L$. Reorders the nodes
	on layer $L$.}*/


	AGDModule *clone() const {
		return new SplitHeuristic();
	}

private:

  void _rek_call
  ( Layer &, CrossingsMatrix &, leda_array<list_item> &pivotpos,
    int low, int high );

};

#endif
