/************************************************************************

         Filename   :   leaves.h

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++


 File containing the header of the class leaves.
 This class manages the pointers to all leaves, which are currently
 in the PQ-tree.

************************************************************************/ 


#ifndef LEAVES_H
#define LEAVES_H

#include <AGD/impl/MaxPlanSub/def.glb>
#include <AGD/impl/MaxPlanSub/pq_node.h>


class leaves {

   public:
     int      size;         // Number of vertices that have leaves.
     int      stack_size;   // Size of the stack.
     pq_node  **leaf_stack; // Array with pointers to the leaves in the
                            // PQ-tree.

     leaves(int m);
     ~leaves();
     
     void insert_ptr(int node,int leaf_nr,pq_node *new_leaf);
                            // If a new leaf is introduced into the tree,
                            // a pointer to it is stored in this procedure.
     pq_node* get_ptr(int node,int leaf_nr);
                            // Reverse procedure to get a certain leaf
                            // corresponding to an edge (node,leaf_nr).
     void remove_ptr(int node,int leaf_nr);
                            // If a leaf is removed from the PQ-tree,
                            // it has to be removed as well from the array. 

};

#endif

