/************************************************************************

         Filename   :   proto.h

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++


 File containing the headers of all procedures of the program.

************************************************************************/ 




#ifndef PROTO_H
#define PROTO_H

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
//#include <sys/times.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <AGD/impl/MaxPlanSub/def.glb>
#include <AGD/impl/MaxPlanSub/adjlists.h>
#include <AGD/impl/MaxPlanSub/stack.h>
#include <AGD/impl/MaxPlanSub/stack_2.h>
#include <AGD/impl/MaxPlanSub/leaves.h>
#include <AGD/impl/MaxPlanSub/pq_node.h>
#include <AGD/impl/MaxPlanSub/queue.h>


/***********************************************************************
                 spanplan.cc
***********************************************************************/

void printtime(
               int t
              );

int cputime();

adjlists* dfs(
         adjlists **graph
        );

void dfs_for_bcc(
                 int node,
                 int *visited,
                 int *label,
                 int *dfbilabel,
                 int *dfbi,
                 int *father,
                 int *blockcount,
                 stack_2 *edgestack,
                 adjlists *graph,
                 adjlists *deleted_edges
                );

void bic_comp_found(
                    stack_2 *edgestack,
                    int blockcount,
                    int node1,
                    int node2,
                    adjlists *deleted_edges
                   );

int st_number(
              adjlists *block,
              int **st_no,
              int **no_st
             );

void print_out_pq_tree(char *name,char *ending,int i);


void printNode(char *filename,int number,
               pq_node* parent,pq_node* son);

	       

/**********************************************************************
                 read_graph.cc
**********************************************************************/

/*
static void chop_cr(
                    char *s
                   );

adjlists* read_graph(
                     char *filename
                    );
*/

                          
/***********************************************************************
                st_num.cc
***********************************************************************/

void st_search(
               adjlists *block,
               adjlists *tree,
               adjlists *back,
               int node,
               int *count,
               int *marked,
               int *father,
               int *low,
               int *dfn
              );
               
int st_path(
            adjlists *tree,
            adjlists *back,
            stack<int> *path,
            int node,
            int *marked,
            int * father,
            int *dfn,
            int *low
           );

void test_st_number(
                    adjlists *block,
                    int *st_no
                   );

void change_numbers(
                    adjlists *block,
                    int *st_no,
                    int count
                   );


/*************************************************************
                plan.cc
**************************************************************/


void planar(
            adjlists *block,
            int sink,
            adjlists *del_edges
           );

stack<int>* get_higher_neighbors(
                                 adjlists *block,
                                 int node
                                );


stack<int>* get_lower_neighbors(
                                adjlists *block,
                                int node
                                );


void replace_Q_node(
                    int node,
                    pq_node *pert_root,
                    leaves *leave_ptr,
                    stack<int> *new_leaves
                   );

void replace_P_node(
                    int node,
                    pq_node *pert_root,
                    leaves *leave_ptr,
                    stack<int> *new_leaves
                   );

void copy_leaves_into_tree(
                           pq_node *tree_node,
                           stack<int> *new_leaves,
                           leaves *leave_ptr,
                           int node
                          );

pq_node* get_father(
                    pq_node *node_ptr
                   );

void check_pert_nodes(
                      stack<pq_node*> *pert_nodes,
                      stack<pq_node*> *killed_nodes
                     );

void bubble(
            int i,
            int sink,
            stack<int> *pertinent_leaves,
            leaves *leave_ptr,
            stack<pq_node*> *pert_nodes
           );


/********************************************************************
                    compute_wha.cc
********************************************************************/
             

void compute1(
              pq_node **pert_root,
              int i,
              int sink,
              stack<int> *pertinent_leaves,
              leaves *leave_ptr,
              adjlists *deleted_edges
             );
            
int sum_pert_child(
                   pq_node *node_ptr
                  );

void set_pert_child(
                    pq_node *node_ptr,
                    int label,
                    int del_typ
                   );

void kill_leaf(
               pq_node *node_ptr,
               int i,
               leaves *leave_ptr,
               adjlists *deleted_edges
              );

int set_h_child(
                pq_node *h_child1
               );

int set_a_children(
                   pq_node *h_child2
                  );

int a1_b1_number(
                 pq_node *node_ptr,
                 pq_node **a_child
                );      

void h_a_num_p_node(
                    pq_node *node_ptr
                   );

void h_a_num_q_node(
                    pq_node *node_ptr
                   );

void delete_leaves(
                   pq_node *pert_root,
                   stack<pq_node*> *comput_stack,
                   int i,
                   leaves *leave_ptr,
                   adjlists *deleted_edges
                  );



/********************************************************************
                  matching.cc
*********************************************************************/

void reduce(
            pq_node **pert_root,
            int i,
            int sink,
            stack<int> *pertinent_leaves,
            leaves *leave_ptr,
            stack<pq_node*> *pert_nodes
           );
            

int template_L1(
                pq_node *node_prt,
                int is_root
               );
                

int template_PQ1(
                 pq_node *node_ptr,
                 int is_root
                );
                 

int template_P2(
                pq_node **node_ptr,
                stack<pq_node*> *pert_nodes
               );


int template_P3(
                pq_node *node_ptr,
                stack<pq_node*> *pert_nodes
               );


int template_P4(
                pq_node **node_ptr,
                stack<pq_node*> *pert_nodes
               );


int template_P5(
                pq_node *node_ptr,
                stack<pq_node*> *pert_nodes
               );


int template_P6(
                pq_node **node_ptr,
                stack<pq_node*> *pert_nodes
               );


int template_Q2(
                pq_node *node_ptr,
                int is_root
               );


int template_Q3(
                pq_node *node_ptr
               );


void P3_copy_full_ch_to_partial(
                                pq_node *node_ptr,
                                pq_node *partial_child,
                                stack<pq_node*> *pert_nodes
                               );


void copy_full_ch_to_partial(
                             pq_node *node_ptr,
                             pq_node *partial_child,
                             stack<pq_node*> *pert_nodes
                            );


pq_node* copy_full_children_from_P_to_P_node(
                                             stack<pq_node*> *S,
                                             stack<pq_node*> *pert_nodes
                                            );


int checkchain(
               pq_node *node_ptr,
               pq_node *first_full,
               pq_node **seq_start,
               pq_node **seq_end
              );


void remove_P_imm_sib(
                      pq_node *node_ptr
                     );


void remove_Q_imm_sib(
                      pq_node *node_ptr
                     );


void change_Q_imm_sib(
                      pq_node *old_node,
                      pq_node *new_node,
                      pq_node *parent
                     );


void change_P_imm_sib(
                      pq_node *old_node,
                      pq_node *new_node
                     );


void removeblock(
                 pq_node *node_ptr,
                 int is_root,
                 pq_node *seq_start,
                 pq_node *seq_end
                );


void check_if_one_son(
                      pq_node *father,
                      pq_node *son
                     );


void mark_killed(
                 pq_node *node_ptr,
                 pq_node *father
                );

void destroy(
             pq_node *node_ptr
            );


#endif




