/************************************************************************

         Filename   :   queue.h

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++


 File containing a class queue, a first-in first-out stack.

************************************************************************/ 


#ifndef QUEUE_H
#define QUEUE_H

#include <AGD/impl/MaxPlanSub/def.glb>
#include "stack.h"


template <class T>
class queue {
     T_elem<T>  *first;     // pointer to the first element of the queue
     T_elem<T>  *last;      // pointer to the last element of the queue
     int        size;       // number of elements in the queue
  public:
     queue();               // constructor of the class queue
     ~queue();              // destructor of the class queue

     int queue_empty();     // true if the queue is empty, false otherwise
     void empty_queue();    // empties the queue
     void enqueue(T m);     // pushes an element T on to the last position of
                            // the stack
     T dequeue();           // gets the first element out of the stack
     T front();             // reads the first element of the stack without
                            // removing it
     int queue_size();      // gets the number of elements stored in the stack
};


template<class T> queue<T>::queue()
{
   first = NULL;
   last = NULL;
   size = 0;
} // constructor


template<class T> queue<T>::~queue()
{
  T_elem<T>  *helpptr;

  while (last != NULL)
  {
     helpptr = last;
     last = last->next;
     delete helpptr;
  } 
} // destructor



template<class T> int queue<T>::queue_empty()
{
   if (size == 0)
      return TRUE;
   else
      return FALSE;
} // queue_empty


template<class T> void queue<T>::empty_queue()
{
   T_elem<T>   *helpptr;

   while (last != NULL)
   {
      helpptr = last;
      last = last->next;
      delete helpptr;
   } 
   first = NULL;
   size = 0;
} // empty_queue


template<class T> void queue<T>::enqueue(T m)
{
  T_elem<T>   *helpptr;

  size++;
  helpptr = new T_elem<T>;
  helpptr->key = m;
  helpptr->next = NULL;
  if (last == NULL)
  {
     last = helpptr;
     first = helpptr;
     helpptr->pre = NULL;
  } 
  else
  {
     first->next = helpptr;
     helpptr->pre = first;
     first = helpptr;
  } 
} // enqueue


template<class T> T queue<T>::dequeue()
{
    T          helpelem;
    T_elem<T>  *helpptr;

    if (last != NULL)
    {
       if (first == last)
          first = NULL;
       helpelem = last->key;
       helpptr = last;
       last = last->next;
       if (last != NULL)
          last->pre = NULL;
       size--;
       delete helpptr;
       return helpelem;
    } 
    else
    {
       printf("template queue: queue empty. wrong access\n");
       return 0;
    } 
} // dequeue

    
template<class T> T queue<T>::front()
{
   if (last != NULL)
      return last->key;
   else
   {
      printf("template queue: queue empty. wrong access when reading element.\n");
      return 0;
   } 
} // front


template<class T> int queue<T>::queue_size()
{
   return size;
} // queue_size

#endif


