#ifndef CLASS_PLAU_CONSTRAINTS
#define CLASS_PLAU_CONSTRAINTS

#include <AGD/impl/planarisator.h>
#include <AGD/impl/plaugment.h>

class PLAU_MASTER;
class EDGEVAR;
class PLAU_EDGEVAR;

//int compare (const EDGEVAR*& evar1, const EDGEVAR*& evar2);

//****************************************************************************
class BICON_CONSTRAINT : public ABA_SROWCON  
{
public:
  BICON_CONSTRAINT (PLAU_MASTER* m, const ABA_ARRAY<int> &sup,
                    const ABA_ARRAY<double> &coeff) :
  ABA_SROWCON ((ABA_MASTER*) m, 0, ABA_CSENSE::Greater, sup.size (), sup, coeff,
               1.0, false, false, false) {}  
}
;
//***************************************************************************
class PLANAR_CONSTRAINT : public ABA_SROWCON
{
 friend class PLAU_SUB;
 public:
   enum VIOLATE_STATUS {NOT_VIOLATED, EQUAL, VIOLATED};
   PLANAR_CONSTRAINT ( ABA_MASTER* m, const ABA_ARRAY<int> &sup,
                       const ABA_ARRAY<double> &coeff, int num = 0);
   inline const char* name()  { return "PLANAR_CONSTRAINT"; }
   inline unsigned hashKey () { return Key; }
   bool equal(ABA_CONVAR* other);
   int find_min (double *values);
   bool is_subset_of (list<int>& varset);
   void print ();
   VIOLATE_STATUS violated_or_equal (double *x, list<int>&);
   int coeff (int var); //returns the coefficient (1 or 0) of variable number var in this constraint
   inline int number () const  { return number_; }

 protected:
   bool violated (ABA_ACTIVE<ABA_VARIABLE, ABA_CONSTRAINT> *vars, double *x, double *sl);
   double slack(ABA_ACTIVE<ABA_VARIABLE, ABA_CONSTRAINT> *variables, double *x);
 private:
   unsigned Key;
   const int number_;
};
#endif
