//-------------------------------------------------------------------
//
//                     GraphWinInterface.c
//
//    author: Carsten Gutwenger, revised by David Alberts
//    date:   june 1997
//-------------------------------------------------------------------


#include <AGD/GraphWinInterface.h>


GraphWinInterface::GraphWinInterface (GraphWin& GW) :
	LayoutInterface(GW.get_graph())
{
	gw_p = &GW;
	old_flush = gw_p->set_flush(false);
}

void GraphWinInterface::init(GraphWin &GW)
{
	gw_p = &GW;
	old_flush = gw_p->set_flush(false);
}

GraphWinInterface::~GraphWinInterface()
{
  gw_p->set_flush(old_flush);
}

void GraphWinInterface::update()
{
  gw_p->set_flush(true);
  gw_p->redraw();
  gw_p->set_flush(false);
}
