//-------------------------------------------------------------------
//
//                       MaxAllMapper.cpp
//
//    author: Carsten Gutwenger
//    date:   february 1997
//-------------------------------------------------------------------


#include <AGD/MaxAllMapper.h>


void MaxAllMapper::init ()
{
	double max_w, max_h;

	get_max_width_height (max_w, max_h);
	set_coeff (Max(max_w,max_h));
}

void MaxAllMapper::get_max_width_height (double& max_w, double& max_h)
{
	const graph& G = graph_A();
	node v;
	double w, h;

	max_w = max_h = 0.0;

	forall_nodes (v, G) {
			w = width  (v);
			h = height (v);
			if (w > max_w) max_w = w;
			if (h > max_h) max_h = h;
	}
}

void MaxAllMapper::set_coeff (double size)
{
	const IRect &bb = gbbox();

	ax = separation() + size;
	bx = left_margin() + size/2 - bb.left() * (separation()+size);

	ay = -separation()-size;
	by = upper_margin() + size/2 + bb.top() * (separation()+size);

	the_bbox = DRect(map_x(bb.left()) - size/2 - left_margin(),
		map_x(bb.right()) + size/2 + left_margin(),
		map_y(bb.top()) - size/2 - upper_margin(),
		map_y(bb.bottom()) + size/2 + upper_margin());
}
