/************************************************************************

         Filename   :   leaves.cc

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++


 File containing the procedures of the class leaves.
 This class manages the pointers to all leaves, which are currently
 in the PQ-tree.

************************************************************************/ 



#include <AGD/impl/MaxPlanSub/leaves.h>
#include <AGD/impl/MaxPlanSub/def.glb>
#include <stdio.h>
#include <stdlib.h>


leaves::leaves(int m)
{
   m++;
   size = m;
   m = m*m;
   stack_size = m;
   leaf_stack = new pq_node*[m];
   for (int i = 0; i < m; i++)
      leaf_stack[i] = NULL;
} // constructor

leaves::~leaves()
{
   delete leaf_stack;
} // destructor


void leaves::insert_ptr(int node,int leaf_nr,pq_node *new_leaf)
{
   leaf_stack[(size*(node-1))+leaf_nr] = new_leaf;
} // insert_ptr


  
pq_node* leaves::get_ptr(int node, int leaf_nr)
{
   return leaf_stack[(size*(node-1))+leaf_nr];
} // get_ptr  



void leaves::remove_ptr(int node, int leaf_nr)
{
   leaf_stack[(size*(node-1))+leaf_nr] = NULL;
} // remove_ptr



