/************************************************************************

         Filename   :   pq_node.cc

         Version    :   09.1994

         Author     :   Sebastian Leipert

         Language   :   C++


 File containing the constructor and destructor of the class pq_node.

************************************************************************/ 




#include <AGD/impl/MaxPlanSub/pq_node.h>
#include <AGD/impl/MaxPlanSub/def.glb>
#include <AGD/impl/MaxPlanSub/stack.h>
#include <stdio.h>
#include <stdlib.h>



pq_node::pq_node(int m,int n,int count,int type,int lbl)
{

   typ = type;
   label = lbl;
   key = m;
   leafnum = n;
   total_count = count;
   w_nr = 0;
   a_nr = 0;
   h_nr = 0;
   del_typ = B;
   child_count = 0;
   visited_child_count = 0;
   not_visited_child_count = 0;
   pert_child_count = 0;
   pert_leaf_count = 0;
   debugTreeNumber = 0;

   parent = NULL;
   h_child1 = NULL;
   h_child2 = NULL;
   a_child = NULL;
   first_full = NULL;
   sib_next = NULL;
   sib_pre = NULL;
   child_sib_list = NULL;
   sib_list_father = NULL;
   

   full_children = new stack<pq_node*>;
   partial_children = new stack<pq_node*>;
   endmost_children = new stack<pq_node*>;
   imm_siblings = new stack<pq_node*>;
} // constructor



pq_node::~pq_node()
{
  full_children->empty_stack();
  partial_children->empty_stack();
  endmost_children->empty_stack();
  imm_siblings->empty_stack();
  delete full_children;
  delete partial_children;
  delete endmost_children;
  delete imm_siblings; 
} //destructor


     
     
